searchNodes=[{"doc":"LetheLethe is a user-friendly query DSL for Mnesia. Currently, Lethe is focused on providing a sane API for reads, but I might add support for writes later.The default options are:Select all fields (Lethe.select_all)Read lock (:read)Select all values (Lethe.limit(:all))","ref":"Lethe.html","title":"Lethe","type":"module"},{"doc":"Compiles the query into a tuple containing all the information needed to run it against an Mnesia database.","ref":"Lethe.html#compile/1","title":"Lethe.compile/1","type":"function"},{"doc":"","ref":"Lethe.html#field_to_var/2","title":"Lethe.field_to_var/2","type":"function"},{"doc":"Limit the number of results returned. The number is a non-negative integer, or the special atom :all to indicate all results being returned. Providing a limit of 0 is functionally equivalent to providing a limit of :all.","ref":"Lethe.html#limit/2","title":"Lethe.limit/2","type":"function"},{"doc":"Create a new query on the specified table. The names of the table attributes will be automatically loaded.","ref":"Lethe.html#new/1","title":"Lethe.new/1","type":"function"},{"doc":"Runs the query against Mnesia, ensuring that results are properly limited.","ref":"Lethe.html#run/1","title":"Lethe.run/1","type":"function"},{"doc":"List specific fields to be selected from the table. Either a single atom or a list of atoms may be provided.","ref":"Lethe.html#select/2","title":"Lethe.select/2","type":"function"},{"doc":"Select all fields from the table. This is essentially Mnesia's :&quot;$$&quot; selector.","ref":"Lethe.html#select_all/1","title":"Lethe.select_all/1","type":"function"},{"doc":"Adds a guard to the query. Guards are roughly analogous to WHERE clauses in SQL, but can operate on all the Elixir data types. Instead of needing to write out guards yourself, or suffer through the scary mess defined in Lethe.Ops, you can instead just write normal Elixir in your where calls, and Lethe will convert them into guard form. For example:# ... |&gt; Lethe.where(:field_name * 2 &lt;= 10) |&gt; Lethe.where(:field_two == 7 and :field_three != &quot;test&quot;) # ...Lethe where expressions are normal Elixir code. Some operators are rewritten from Elixir form to Mnesia form at compile time; for example, Elixir's and operator is rewritten to an :andalso Mnesia guard.A list of all available functions can be found here: https://erlang.org/doc/apps/erts/match_spec.html#grammar","ref":"Lethe.html#where/2","title":"Lethe.where/2","type":"macro"},{"doc":"","ref":"Lethe.html#t:compiled_query/0","title":"Lethe.compiled_query/0","type":"type"},{"doc":"An Elixir expression. Used for where clauses.","ref":"Lethe.html#t:expression/0","title":"Lethe.expression/0","type":"type"},{"doc":"The fields being returned by the query. These are the names of the fields, not Mnesia's numeric selectors or anything of the like.","ref":"Lethe.html#t:field/0","title":"Lethe.field/0","type":"type"},{"doc":"","ref":"Lethe.html#t:field_or_guard/0","title":"Lethe.field_or_guard/0","type":"type"},{"doc":"The limit of values to return. If the limit is 0, it is converted to :all internally.","ref":"Lethe.html#t:limit/0","title":"Lethe.limit/0","type":"type"},{"doc":"The type of table lock to use.","ref":"Lethe.html#t:lock/0","title":"Lethe.lock/0","type":"type"},{"doc":"","ref":"Lethe.html#t:matchspec/0","title":"Lethe.matchspec/0","type":"type"},{"doc":"","ref":"Lethe.html#t:matchspec_all/0","title":"Lethe.matchspec_all/0","type":"type"},{"doc":"","ref":"Lethe.html#t:matchspec_any/0","title":"Lethe.matchspec_any/0","type":"type"},{"doc":"A boolean function that can be invoked in a matchspec. These functions are used for operating on the values being queried over, such as:&quot;is X a pid?&quot;&quot;is Y a key in X?&quot;","ref":"Lethe.html#t:matchspec_bool_func/0","title":"Lethe.matchspec_bool_func/0","type":"type"},{"doc":"","ref":"Lethe.html#t:matchspec_condition/0","title":"Lethe.matchspec_condition/0","type":"type"},{"doc":"The first tuple() is a {table(), result() | matchspec_any(), ...}","ref":"Lethe.html#t:matchspec_element/0","title":"Lethe.matchspec_element/0","type":"type"},{"doc":"","ref":"Lethe.html#t:matchspec_guard/0","title":"Lethe.matchspec_guard/0","type":"type"},{"doc":"","ref":"Lethe.html#t:matchspec_guard_func/0","title":"Lethe.matchspec_guard_func/0","type":"type"},{"doc":"","ref":"Lethe.html#t:matchspec_variable/0","title":"Lethe.matchspec_variable/0","type":"type"},{"doc":"","ref":"Lethe.html#t:result/0","title":"Lethe.result/0","type":"type"},{"doc":"","ref":"Lethe.html#t:results/0","title":"Lethe.results/0","type":"type"},{"doc":"The name of the Mnesia table to query against","ref":"Lethe.html#t:table/0","title":"Lethe.table/0","type":"type"},{"doc":"A result of an Mnesia transaction.","ref":"Lethe.html#t:transaction/1","title":"Lethe.transaction/1","type":"type"},{"doc":"A failed transaction result. The inner term is the error returned by Mnesia.","ref":"Lethe.html#t:transaction_failure/0","title":"Lethe.transaction_failure/0","type":"type"},{"doc":"A successful transaction result.","ref":"Lethe.html#t:transaction_success/1","title":"Lethe.transaction_success/1","type":"type"},{"doc":"","ref":"Lethe.AstTransformer.html","title":"Lethe.AstTransformer","type":"module"},{"doc":"Auto-generated Mnesia guard helpers. YOU DO NOT WANT TO USE THIS MODULE EVER.","ref":"Lethe.Ops.html","title":"Lethe.Ops","type":"module"},{"doc":"","ref":"Lethe.Ops.html#*/2","title":"Lethe.Ops.*/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#+/2","title":"Lethe.Ops.+/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#-/2","title":"Lethe.Ops.-/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#/=/2","title":"Lethe.Ops./=/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#%3C/2","title":"Lethe.Ops.</2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#=/=/2","title":"Lethe.Ops.=/=/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#=:=/2","title":"Lethe.Ops.=:=/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#=%3C/2","title":"Lethe.Ops.=</2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#==/2","title":"Lethe.Ops.==/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#%3E/2","title":"Lethe.Ops.>/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#%3E=/2","title":"Lethe.Ops.>=/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#abs/1","title":"Lethe.Ops.abs/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#andalso/2","title":"Lethe.Ops.andalso/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#band/2","title":"Lethe.Ops.band/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#bit_size/1","title":"Lethe.Ops.bit_size/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#bnot/2","title":"Lethe.Ops.bnot/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#bor/2","title":"Lethe.Ops.bor/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#bsl/2","title":"Lethe.Ops.bsl/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#bsr/2","title":"Lethe.Ops.bsr/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#bxor/2","title":"Lethe.Ops.bxor/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#constant_funcs/0","title":"Lethe.Ops.constant_funcs/0","type":"function"},{"doc":"","ref":"Lethe.Ops.html#div/2","title":"Lethe.Ops.div/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#element/1","title":"Lethe.Ops.element/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#hd/1","title":"Lethe.Ops.hd/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_atom/1","title":"Lethe.Ops.is_atom/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_binary/1","title":"Lethe.Ops.is_binary/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_float/1","title":"Lethe.Ops.is_float/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_funcs/0","title":"Lethe.Ops.is_funcs/0","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_function/1","title":"Lethe.Ops.is_function/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_integer/1","title":"Lethe.Ops.is_integer/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_list/1","title":"Lethe.Ops.is_list/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_map/1","title":"Lethe.Ops.is_map/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_map_key/2","title":"Lethe.Ops.is_map_key/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_number/1","title":"Lethe.Ops.is_number/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_pid/1","title":"Lethe.Ops.is_pid/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_port/1","title":"Lethe.Ops.is_port/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_reference/1","title":"Lethe.Ops.is_reference/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#is_tuple/1","title":"Lethe.Ops.is_tuple/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#length/1","title":"Lethe.Ops.length/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#logical_funcs/0","title":"Lethe.Ops.logical_funcs/0","type":"function"},{"doc":"","ref":"Lethe.Ops.html#map_get/1","title":"Lethe.Ops.map_get/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#map_size/1","title":"Lethe.Ops.map_size/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#node/0","title":"Lethe.Ops.node/0","type":"function"},{"doc":"","ref":"Lethe.Ops.html#not/2","title":"Lethe.Ops.not/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#operator_funcs/0","title":"Lethe.Ops.operator_funcs/0","type":"function"},{"doc":"","ref":"Lethe.Ops.html#orelse/2","title":"Lethe.Ops.orelse/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#rem/2","title":"Lethe.Ops.rem/2","type":"function"},{"doc":"","ref":"Lethe.Ops.html#round/1","title":"Lethe.Ops.round/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#self/0","title":"Lethe.Ops.self/0","type":"function"},{"doc":"","ref":"Lethe.Ops.html#size/1","title":"Lethe.Ops.size/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#tl/1","title":"Lethe.Ops.tl/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#transform_funcs/0","title":"Lethe.Ops.transform_funcs/0","type":"function"},{"doc":"","ref":"Lethe.Ops.html#trunc/1","title":"Lethe.Ops.trunc/1","type":"function"},{"doc":"","ref":"Lethe.Ops.html#xor/2","title":"Lethe.Ops.xor/2","type":"function"},{"doc":"A Lethe query. Queries are what Lethe transforms into Mnesia-compatible matchspecs for processing. A query is constructed from nothing but a table name, provided to Lethe.new/1. Queries have sane defaults:Return all fieldsRead lockReturn all matchesQueries can be updated with several functions:Lethe.where/2: Add a constraint to the query, like a WHERE clause in SQL.Lethe.limit/2: Limit the number of results returned by the query.Lethe.select/2: Choose the specific fields returned by the query.Lethe.select_all/1: Choose to return all fields.When you're finished creating a query, you must then compile it with Lethe.compile/1, which converts the query into a form that can be passed to Mnesia. Copmiled queries can be executed with Lethe.run/1; while it is possible to take the output from Lethe.compile/1 and run it manually, doing so is not advised.","ref":"Lethe.Query.html","title":"Lethe.Query","type":"module"},{"doc":"","ref":"Lethe.Query.html#t:t/0","title":"Lethe.Query.t/0","type":"type"},{"doc":"LetheLethe /ˈli θi/ • noun &lt;sup&gt;&lt;sup&gt;(try it with IPA Reader)&lt;/sup&gt;&lt;/sup&gt;Classical Mythology. A river in Hades whose water caused forgetfulness of the past in those who drank of it.A marginally-better (WIP) query DSL for Mnesia. Originally implemented for 신경.Matchspecs suck, so this is a sorta-better alternative.WARNING: Currently, only read operations are supported. This may or may not change in the future.","ref":"readme.html","title":"Lethe","type":"extras"},{"doc":"[x] Select all fields of a record[x] Select some fields of a record[x] Limit number of records returned[x] Query operators[x] +, -, *, div, rem, &gt;, &gt;=, &lt;, &lt;=, !=[x] Bitwise operators[x] Tuple, list, and map operators (map_size, hd, tl, element, etc.)[x] Misc. math functions (abs, trunc, etc.)[x] Boolean operators[x] Logical AND/OR/etc.[x] is_pid/is_binary/etc.[ ] Write DSL","ref":"readme.html#roadmap","title":"Lethe - Roadmap","type":"extras"},{"doc":"Get it on Hex.Read the docs.","ref":"readme.html#installation","title":"Lethe - Installation","type":"extras"},{"doc":"# Create a table... table = :table :mnesia.create_schema [] :mnesia.start() :mnesia.create_table table, [attributes: [:integer, :string, :map]] # ...and add some indexes... :mnesia.add_table_index table, :integer :mnesia.add_table_index table, :string :mnesia.add_table_index table, :map # ...and some test data. n = fn -&gt; :rand.uniform 1_000_000_000_000_000_000_000_000_000_000_000_000_000_000_000 end for i &lt;- 1..10_000, do: :mnesia.dirty_write {table, i, &quot;\#{n.()}&quot;, %{n.() =&gt; &quot;\#{n.()}&quot;}} # Now let's run some queries! # Lethe's query DSL allows you to use the names of your table attributes, # rather than forcing you to think about what their index in the record is, or # anything else like that. # Currently, Lethe requires that you compile your queries before running them. # This is primarily done to aid in debugging, and a `Lethe.compile_and_run/1` # is likely to happen in the future. # Select one record and all its fields {:ok, [{integer, string, map}]} = table |&gt; Lethe.new |&gt; Lethe.limit(1) |&gt; Lethe.select_all |&gt; Lethe.compile |&gt; Lethe.run # Select all fields from all records # `Lethe.select_all` and `Lethe.limit(:all)` are the default settings. {:ok, all_records} = table |&gt; Lethe.new |&gt; Lethe.compile |&gt; Lethe.run # Select a single field from a single record {:ok, [integer]} = table |&gt; Lethe.new |&gt; Lethe.limit(1) |&gt; Lethe.select(:integer) |&gt; Lethe.compile |&gt; Lethe.run # Select a bunch of records at once {:ok, records} = table |&gt; Lethe.new |&gt; Lethe.limit(100) |&gt; Lethe.compile |&gt; Lethe.run # Select specific fields from a record {:ok, [{int, map}, {int, map}]} = table |&gt; Lethe.new |&gt; Lethe.limit(2) |&gt; Lethe.select([:integer, :map]) |&gt; Lethe.compile |&gt; Lethe.run # Now let's use some operators! # Lethe internally rewrites all of these expressions into Mnesia guard form. # Select all values where :integer * 2 &lt;= 10 {:ok, res} = table |&gt; Lethe.new |&gt; Lethe.select(:integer) |&gt; Lethe.where(:integer * 2 &lt;= 10) |&gt; Lethe.compile |&gt; Lethe.run {:ok, res} = table |&gt; Lethe.new |&gt; Lethe.select(:integer) |&gt; Lethe.where(:integer * 2 &gt;= 4 and :integer * 2 &lt;= 10) |&gt; Lethe.compile |&gt; Lethe.run # See the documentation on `Lethe.where/2` for a list of all available ops","ref":"readme.html#usage","title":"Lethe - Usage","type":"extras"}]